
CREATE TABLE Announcements 
  (
    id          VARCHAR PRIMARY KEY, 
    eventId     VARCHAR NOT NULL, 
    publishOn   DATETIME, 
    sentBy      VARCHAR, 
    subject     VARCHAR, 
    body        VARCHAR, 
    modified    DATETIME, 
    deleted     INTEGER DEFAULT 0, 
    isRead      INTEGER DEFAULT 0,
    FOREIGN KEY (eventId) REFERENCES Events(id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED
  );;

CREATE TRIGGER Announcements_Object_Insert AFTER INSERT ON Announcements
BEGIN
    INSERT INTO Objects (id, objectClass) VALUES (NEW.id, 'announcement');
END;;

CREATE TRIGGER Announcements_Object_Delete AFTER DELETE ON Announcements 
BEGIN
    DELETE FROM Objects WHERE Objects.id = OLD.id;
END;;
