
DROP TABLE Affiliations;;

CREATE TABLE Affiliations 
  ( 
     id              VARCHAR NOT NULL PRIMARY KEY,
     eventId         VARCHAR NOT NULL, 
     personId        VARCHAR NOT NULL REFERENCES Persons(id) DEFERRABLE INITIALLY DEFERRED, 
     institutionId   VARCHAR NOT NULL REFERENCES Institutions(id) DEFERRABLE INITIALLY DEFERRED, 
     typeId          VARCHAR REFERENCES Types(id) DEFERRABLE INITIALLY DEFERRED,
     position        VARCHAR,
     ordering        INTEGER DEFAULT 0, 
     inverseOrdering INTEGER DEFAULT 0, 
     FOREIGN KEY (eventId) REFERENCES Events(id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED
  );; 

CREATE TRIGGER Affiliations_Object_Insert AFTER INSERT ON Affiliations
BEGIN
    INSERT INTO Objects (id, objectClass) VALUES (NEW.id, 'affiliation');
END;;

CREATE TRIGGER Affiliations_Object_Delete AFTER DELETE ON Affiliations
BEGIN
    DELETE FROM Objects WHERE Objects.id = OLD.id;
END;;

DROP TABLE Extras;;

CREATE TABLE ObjectExtras 
  ( 
     objectId VARCHAR, 
     key      VARCHAR, 
     value    VARCHAR,
     PRIMARY KEY (objectId, key),
     FOREIGN KEY (objectId) REFERENCES Objects(id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED
  );;

CREATE TABLE QuestionnaireAssociations 
  ( 
     eventId         VARCHAR NOT NULL, 
     objectId        VARCHAR NOT NULL REFERENCES Objects(id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED, 
     questionnaireId VARCHAR NOT NULL, 
     PRIMARY KEY (objectId, questionnaireId),
     FOREIGN KEY (eventId) REFERENCES Events(id) ON DELETE CASCADE DEFERRABLE INITIALLY DEFERRED
  );; 
